-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : Build Firends Tooltip for Titan Panel
-- **************************************************************************
function TitanPanelPals_SetTooltip()
     local np, op = GetNumFriends();
     local BNNumF, BNetCount = BNGetNumFriends();
     local ofI, opn, opl, opc, opa, opco, ops, opno, tpcnp, tpai;
     local right, left;
     if ( np == 0 and BNNumF == 0 ) then
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_EMPTY"])
     else
          -- RealID Friends
          if ( TitanPals.Settings.ShowBNTooltip ) then
               local BNNumF, BNetCount = BNGetNumFriends();
               local BNI, TText, FirstN, LastN, BNAFK, BNDND, ToonID, TName, TClient, TRealm, TFaction, TRace, TClass, TGuild, TZone, TLevel, TStatus, TNote, right, left, BNToonCount;
               GameTooltip:AddLine(LB["TITAN_PALS_REAL_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
               if ( BNetCount > 0 ) then
	            for BNI=1, BNetCount do
			 BNToonCount = BNGetNumFriendToons(BNI);
	                 _, FirstN, LastN, _, ToonID, TGame, _, _, BNAFK, BNDND, _, TNote = BNGetFriendInfo(BNI);
			 AccountN = FirstN.." "..LastN
                         for i=1, BNToonCount do

                         TFocus, TName, TClient, TRealm, TFaction, TRace, TClass, TGuild, TZone, TLevel, TText = BNGetFriendToonInfo(BNI, i);

--			 TitanPanelPals_DebugUtils("bug", "tooltip", AccountN.." has "..BNToonCount.." toons online right now")
                         TitanPanelPals_DebugUtils("bug", "Tooltip", "\nI = "..i.." \nReal Name "..AccountN.." \nCharacter Name "..TName.." \nCharacter ID "..ToonID.." \nClient "..TGame.." \nGameText "..TText);
			 --[[ This is ALPHA code and will be altered as needed ]]--
                         if ( TGame == "S2" ) then
                              TLevel = "-";
                              TClass = "S2";
			      TRealm = "Starcraft II"
                         end
			 if ( BNAFK ) then BNAFK = "<Away>";
			 else BNAFK = "nil"; end
			 if ( BNDND ) then BNDND = "<DND>";
			 else BNDND = "nil"; end
			 TStatus = BNAFK..":"..BNDND;
                         RealIDName = TitanPanelPals_CoreUtils("RealIDN", TitanPals.Settings.RealIDFormat, FirstN, LastN, TName, TRealm, AccountN, TClass, TGame)
                         if ( TGame == "S2" ) then
                              right, left = TitanPanelPals_CoreUtils("ToolTip", TitanPals.Settings.TFormat, "", RealIDName, TLevel, TClass, TText, TStatus, "");
			 else
                              right, left = TitanPanelPals_CoreUtils("ToolTip", TitanPals.Settings.TFormat, "", RealIDName, TLevel, TClass, TZone, TStatus, TNote);
                         end
                         GameTooltip:AddDoubleLine(right, left);
                         end
                    end
                    GameTooltip:AddLine("\n");
               else 
                    GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_NOREALPALS"]);
                    GameTooltip:AddLine("\n");
               end
          end
          GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

          -- For showing online friends
          if ( op == 0 ) then GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_NOPALS"]);
          else
               for ofI=1, np do
                    opn, opl, opc, opa, opco, ops, opno = GetFriendInfo(ofI);
                    if ( opco ) then
                         right, left = TitanPanelPals_CoreUtils("ToolTip", TitanPals.Settings.TFormat, "", opn, opl, opc, opa, ops, opno);
                         GameTooltip:AddDoubleLine(right, left);
                    end
               end
          end

	  -- For showing ignored ppl
          if ( TitanPals.Settings.ShowIgnored ) then
               GameTooltip:AddLine("\n");
               GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_IGNORE"]));
               ni = GetNumIgnores();
               if ( ni == 0 ) then 
	            GameTooltip:AddLine(LB["TITAN_PALS_TOOLTIP_IGNORE_EMPTY"]);
               else
                    for ofI=1, ni do
                         local tpit = TitanPanelPals_ColorUtils("GetCText", "red", LB["TITAN_PALS_TOOLTIP_OFFLINE_IGNORED"]);
                         GameTooltip:AddDoubleLine("  "..TitanPanelPals_ColorUtils("GetCText", "normal", GetIgnoreName(ofI)), tpit);
                    end
               end
          end
     end
     -- For showing AddOn memory Usage
     if ( TitanPals.Settings.ShowMem ) then
          GameTooltip:AddLine("\n");
          GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_MEM"]));
	  GameTooltip:AddDoubleLine("  "..LB["TITAN_PALS_CONFIG"], TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb"))
     end
end